/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ {ʐMJ[h ]
 */

#ifndef _jsubsys_h_
#define _jsubsys_h_

#if XM7_VER == 1 && defined(JSUB)

#ifdef __cplusplus
extern "C" {
#endif

/*
 *	Gg
 */
BOOL FASTCALL jsubsys_init(void);
										/* {TuVXe  */
void FASTCALL jsubsys_cleanup(void);
										/* {TuVXe N[Abv */
void FASTCALL jsubsys_reset(void);
										/* {TuVXe Zbg */
void FASTCALL jsubcpu_execline(void);
										/* {TuCPU Pss */
void FASTCALL jsubcpu_exec(void);
										/* {TuCPU s */
void FASTCALL jsubcpu_nmi(void);
										/* {TuCPU NMI荞ݗv */
void FASTCALL jsubcpu_firq(void);
										/* {TuCPU FIRQ荞ݗv */
void FASTCALL jsubcpu_irq(void);
										/* {TuCPU IRQ荞ݗv */
BYTE FASTCALL jsubmem_readb(WORD addr);
										/* {Tu ǂݏo */
BYTE FASTCALL jsubmem_readbnio(WORD addr);
										/* {Tu ǂݏo(I/O) */
void FASTCALL jsubmem_writeb(WORD addr, BYTE dat);
										/* {Tu  */
BOOL FASTCALL jsubsys_readb(WORD addr, BYTE *dat);
										/* {TuI/O ǂݏo */
BOOL FASTCALL jsubsys_writeb(WORD addr, BYTE dat);
										/* {TuI/O  */
BOOL FASTCALL jsub_readb(WORD addr, BYTE *dat);
										/* {TuI/F ǂݏo */
BOOL FASTCALL jsub_writeb(WORD addr, BYTE dat);
										/* {TuI/F  */
BOOL FASTCALL jsubsys_save(int fileh);
										/* {TuVXe Z[u */
BOOL FASTCALL jsubsys_load(int fileh, int ver);
										/* {TuVXe [h */
extern BYTE FASTCALL jsub_readrcb(void);
										/* RCB[h */
extern void FASTCALL jsub_writercb(BYTE);
										/* RCBCg */
extern void FASTCALL jsub_clear_address(void);
										/* RCBAhXJE^NA */

/*
 *	[NGA
 */
extern BOOL jsub_haltflag;
										/* {TuVXeHALTtO */
extern BOOL jsub_available;
										/* {Tugp\tO */
extern BOOL jsub_enable;
										/* {TugptO */
#ifdef __cplusplus
}
#endif

#endif

#endif	/* _jsubsys_h_ */
